Subject: Re: installer improvements
From: Morgan Gangwere <[email-masked]>
To: [email-masked]
Date: Tue, 6 Apr 2010 10:29:15 -0600
List-Id: <cygwin.cygwin.com>

On Tue, Apr 6, 2010 at 8:10 AM, wefwef wefwef <[email-masked]> wrote:
>>> After using cygwin for years, and having some recent difficulty
>>> installing, I took a look at the installer to actually try and
>>> understand it (a novel concept I know!).

Your problem was that a package didnt get installed because you would
have had to explicitly told it not to have been.

>>> Here are my thoughts on the gui - I think it could be made considerably
>>>  more user friendly with some minor cosmetic changes.
>>
>> Personally, as a UI fanatic, I have no problem with it, and I get really
>> nitpicky about design. Lets hear your gripes, shall we? :)
>>
>>> The View button is being used to do two separate and unrelated tasks.
>>> - Switch between category and list view
>>> - Choose between partial, up to date, and not installed.
>>> I suggest that additional radio buttons be used to select between
>>> category and list view.
>>
>> They are *not* unrelated. In fact, that button keeps me *sane*
>
> how do you choose full view in category mode, full view in list mode,
> partial view in category mode, partial view in list mode, not
> installed in category mode, not installed in list mode ?

they dont exist because packages can exist in multiple categories
(apache in "web" and "network", xbiff in "X11" and "Network", etc)

>>
>> What it does is change the perspective of looking at the packages; the fact
>> that one view happens to be a tree view ("by category") instead of a
>> linear-list ("by is-installed" or "is-downloaded") is a happy 2nd or 3rd
>> order effect. *any other way of doing it would be a kludgy look*.
> So you are saying that the single button has a second order effect.
> Normally, you would put this 'second order effect' on a different gui
> component so it could be controlled separately. In effect, the view
> button tries to do two things - one is how you see what is currently
> selected (list or category), the other is to select what you see. Why
> on earth you would want to choose these functions with the same button
> I don't know.

no, the second order effect is that in category view, it is set up in
a tree-list instead of (oh i dont know) sorted by the category in a
column.

>>
>>> The terms used are not the clearest (and believe me, things are tricky
>>> enough already)
>>> Partial              -   I suggest change to 'to be be installed' or
>>> similar
>>> Up to date        -   I suggest change to 'already installed' or similar
>>> not installed     -   this is clear, no changes necessary
>>
>> Partial: Downloaded (or marked for download/Updatable), but not installed.
>> Up To Date: Downloaded, Installed and latest version.
>> Not Installed: Self Referential.
> Yes, I know you can explain the terms to me, good design however is
> self explanatory.
>>
>>> The way that (partial, up to date and not installed) is selected, via
>>> clicking on a button multiple times is not very common in gui design.
>>
>> It sure as hell is. Look at Synaptic: Uses the same ideology; If the debian
>> folks were braindamaged (which, frankly, some of them are) they would be
>> working on GNOME projects (Except Synaptic, which also has this ability)
> Where else? - I don't see it everywhere in all the gui's I use - I do
> however see radio buttons and drop down lists everywhere.

I'll point to Microsoft's Visual Studio installers of past. I dont
have the RC for vs2010 but I can speculate its the same as most of the
other ones: a button to change one things, another button to change
something else, and more buttons to change how you see things.

AVR Studio uses view-modes as well, changing the entire layout of the
application depending on what you are doing at the moment (be it
flashing a device, debugging a device, etc)

>>
>>> It doesn't allow you to see all of the available choices at once. I
>>> suggest replacing this button either with a group of radio buttons, or
>>> a drop down list similar to the way that you can change the view in a
>>> windows folder (details, list, icons).
>>
>> I believe the view-mode you're looking for is "full"
> No, I'm looking for a logical way of selecting the view mode.

I believe you are looking for the "view" button then.

>>
>>> I suggest that a new column be introduced, indicating whether a
>>> package is already installed or not. The installer has this
>>> information - it would be nice if it made it available to the user.
>>
>> There's already two of those -- they're called "Bin?" and "Src?" -- which
>> indicate if the binary and/or source packages are installed.
> Well, actually the column that does this is called Current, which was
> pointed out to me by Dave Korn.

>>> I suggest that a new column be introduced, indicating whether a
>>> package is already installed or not.
Sounds to me like a boolean. Bin? and Src? do that.

> Choosing the fastest server could save a lot longer than 45 seconds in
> download time. This functionality would be useful and could be an
> option available to users if they wanted to automatically find the
> fastest server.

Ever wondered why there's 50 or so servers to choose from? because it
assumes that when you choose you are able to figure out that its
proabably faster to get data from somewhere closer to you.

> Clever you. What's that got to do with anything? You see, to end up
> with good quality software, you have to search out flaws, and fix
> them. Just because you could install 5 years ago, doesn't mean the
> installer is the best it could be.

Its that that was my first Cygwin install. Ever. I was downloading it
to run some work I was dealing with at school (we used linux at school
and I wanted to test some code) but didnt want to dual boot because I
didnt know how to get it set up with XP.

As a test I asked a collegue of mine, who barely knows how to use
office, to install Cygwin on a machine with gvim, Xorg and some other
things. With explaination about package names, they were able to do it
without a problem.

Stop trying to "fix" the interface unless you are volunteering to take
over the project.
-- 
Morgan gangwere

“The future’s already arrived. It’s just not evenly distributed yet.”
William Gibson

--
Problem reports:       http://cygwin.com/problems.html
FAQ:                   http://cygwin.com/faq/
Documentation:         http://cygwin.com/docs.html
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple